#
# Example wscp script for creating a JDBCDriver and DataSource object
# The script init.tcl must be loaded prior to running this script
# For the JDBC Driver, substitute different values for the implementation class, 
# URL prefix, and JAR file as needed



set jdbc "/JDBCDriver:DB2Driver/"
# Create a JDBCDriver object
    set cmd {JDBCDriver create $jdbc -attribute {{ImplClass com.ibm.db2.jdbc.app.DB2Driver}{JTAEnabled true}{UrlPrefix jdbc:db2}}}
    if {$VERBOSE} {puts [subst "# $cmd"]}
    eval $cmd


set data "/DataSource:testDataSource/"
# Create a DataSource object
    set attrs "{DatabaseName WAS}{JDBCDriver $jdbc}"
    set cmd {DataSource create $data -attribute $attrs}
    if {$VERBOSE} {puts [subst "# $cmd"]}
    eval $cmd


# Install the JDBCDriver object
    set cmd {JDBCDriver install $jdbc -node $NODE -jarFile ${DB2_HOME}${FILE_SEPARATOR}java${FILE_SEPARATOR}db2java.zip}
    if {$VERBOSE} {puts [subst "# $cmd"]}
    eval $cmd

# Optional commands for uninstalling the JDBCDriver object and removing the DataSource object

if {0} {

# Uninstall the JDBCDriver object
    set cmd {JDBCDriver uninstall $jdbc -node $NODE}
    if {$VERBOSE} {puts [subst "# $cmd"]}
    eval $cmd


# Remove the DataSource object just created
    set cmd {DataSource remove $data}
    if {$VERBOSE} {puts [subst "# $cmd"]}
    eval $cmd


# Remove the JDBCDriver object just created
    set cmd {JDBCDriver remove $jdbc}
    if {$VERBOSE} {puts [subst "# $cmd"]}
    eval $cmd

}
