// 5648-C84, 5648-C83, (C) Copyright IBM Corporation, 1997, 2000
// All rights reserved. Licensed Materials Property of IBM
// Note to US Government users: Documentation related to restricted rights
// Use, duplication or disclosure is subject to restrictions set forth in GSA ADP Schedule with IBM Corp.
// This page may contain other proprietary notices and copyright information, the terms of which must be observed and followed.
//
// This program may be used, executed, copied, modified and distributed
// without royalty for the purpose of developing, using,
// marketing, or distributing.

/**
*
* Description - SurveyResults
*/ 
package WebSphereSamples.Survey;
// Imports
import com.ibm.servlet.*;
import com.ibm.webtools.runtime.*;
import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;

// Imports for beans used by this servlet
import WebSphereSamples.Survey.SurveyResultsDBBean;

public class SurveyResults extends com.ibm.webtools.runtime.StudioPervasiveServlet implements Serializable
{

/*  ****************************************************************************
  * Process incoming requests for information
  * 
  * @param request Object that encapsulates the request to the servlet
  * @param response Object that encapsulates the response from the servlet
  */
   public void performTask(HttpServletRequest request, HttpServletResponse response)
   {
      try
      {
         // Instantiate the beans and store them so they can be accessed by the called page
         WebSphereSamples.Survey.SurveyResultsDBBean surveyResultsDBBean = null;
         surveyResultsDBBean = (WebSphereSamples.Survey.SurveyResultsDBBean) java.beans.Beans.instantiate(getClass().getClassLoader(), "WebSphereSamples.Survey.SurveyResultsDBBean");

         setRequestAttribute("surveyResultsDBBean", surveyResultsDBBean, request);

         // Initialize the bean URL property from the webapp URL attribute
         surveyResultsDBBean.setURL((String)getServletConfig().getServletContext().getAttribute("URL"));

         // Initialize the bean driver property from the parameters
         surveyResultsDBBean.setDriver(getParameter(request, "driver", true, true, false, null));

         // Initialize the bean survey_id property from the parameters
         surveyResultsDBBean.setSurvey_id(getParameter(request, "survey_id", true, true, true, null));

         // Initialize the bean user_id property from the parameters
         surveyResultsDBBean.setUser_id(getParameter(request, "user_id", true, true, true, null));

         // Initialize the bean q1 property from the parameters
         surveyResultsDBBean.setQ1(getParameter(request, "q1", true, true, true, null));

         // Initialize the bean q2 property from the parameters
         surveyResultsDBBean.setQ2(getParameter(request, "q2", true, true, true, null));

         // Initialize the bean q3 property from the parameters
         surveyResultsDBBean.setQ3(getParameter(request, "q3", true, true, true, null));

         // Initialize the bean q4 property from the parameters
         surveyResultsDBBean.setQ4(getParameter(request, "q4", true, true, true, null));

         // Initialize the bean q5 property from the parameters
         surveyResultsDBBean.setQ5(getParameter(request, "q5", true, true, true, null));

         // Call the execute action on the bean.
         surveyResultsDBBean.execute();

         // Call the output page. If the output page is not passed
         // as part of the URL, the default page is called.
         callPage(getPageNameFromRequest(request), request, response);
      }

      catch (Throwable theException)
      {
         handleError(request, response, theException);
      }
   }
}
