// 5648-C84, 5648-C83, (C) Copyright IBM Corporation, 1997, 2000
// All rights reserved. Licensed Materials Property of IBM
// Note to US Government users: Documentation related to restricted rights
// Use, duplication or disclosure is subject to restrictions set forth in GSA ADP Schedule with IBM Corp.
// This page may contain other proprietary notices and copyright information, the terms of which must be observed and followed.
//
// This program may be used, executed, copied, modified and distributed
// without royalty for the purpose of developing, using,
// marketing, or distributing.

/**
*
* Description - PreferredLinksDBBean
*/
package WebSphereSamples.YourCo.Employee;
// Imports
import com.ibm.db.*;
import com.ibm.webtools.runtime.*;
import java.io.*;
import java.math.*;

// Imports for App Server V3 connection pooling
import javax.sql.DataSource;
import com.ibm.ejs.dbm.jdbcext.*;
import java.sql.*;
import java.util.*;
import com.ibm.websphere.advanced.cm.factory.*;
import javax.naming.*;

public class PreferredLinksDBBean extends java.lang.Object
{
   /**
   * Instance variable for driver property
   */
   protected java.lang.String driver = null;

   /**
   * Instance variable for empno property
   */
   protected java.lang.String empno = null;

   /**
   * Instance variable for URL property
   */
   protected java.lang.String URL = null;

   /**
   * Variable to hold DataSource
   */
   protected DataSource ds = null;

   /**
   * Variable to hold connection
   */
   protected Connection connection = null;

   /**
   * Vector to hold LINKS_CATEGORY property values
   */
   protected Vector LINKS_CATEGORYVector = new Vector();

   /**
   * Vector to hold LINKS_URL property values
   */
   protected Vector LINKS_URLVector = new Vector();

   /**
   * Vector to hold LINKS_LINK_NAME property values
   */
   protected Vector LINKS_LINK_NAMEVector = new Vector();

   /*****************************************************************************
   * Get method for the indexed LINKS_CATEGORY property
   * @param index The 0 based index of the desired value
   * @return the value of the LINKS_CATEGORY property at the specified index
   */
   public java.lang.String getLINKS_CATEGORY(int index)
   throws java.lang.ArrayIndexOutOfBoundsException
   {
      return (String)LINKS_CATEGORYVector.elementAt(index);
   }

   /*****************************************************************************
   * Get method for the indexed LINKS_URL property
   * @param index The 0 based index of the desired value
   * @return the value of the LINKS_URL property at the specified index
   */
   public java.lang.String getLINKS_URL(int index)
   throws java.lang.ArrayIndexOutOfBoundsException
   {
      return (String)LINKS_URLVector.elementAt(index);
   }

   /*****************************************************************************
   * Get method for the indexed LINKS_LINK_NAME property
   * @param index The 0 based index of the desired value
   * @return the value of the LINKS_LINK_NAME property at the specified index
   */
   public java.lang.String getLINKS_LINK_NAME(int index)
   throws java.lang.ArrayIndexOutOfBoundsException
   {
      return (String)LINKS_LINK_NAMEVector.elementAt(index);
   }

   /*****************************************************************************
   * Get method for the driver property
   * @return the value of the driver property
   */
   public java.lang.String getDriver()
   {
      return driver;
   }

   /*****************************************************************************
   * Set method for the driver property
   * @param value the new value for the driver property
   */
   public void setDriver(java.lang.String value)
   {
      this.driver = value;
   }

   /*****************************************************************************
   * Get method for the empno property
   * @return the value of the empno property
   */
   public java.lang.String getEmpno()
   {
      return empno;
   }

   /*****************************************************************************
   * Set method for the empno property
   * @param value the new value for the empno property
   */
   public void setEmpno(java.lang.String value)
   {
      this.empno = value;
   }

   /*****************************************************************************
   * Get method for the URL property
   * @return the value of the URL property
   */
   public java.lang.String getURL()
   {
      return URL;
   }

   /*****************************************************************************
   * Set method for the URL property
   * @param value the new value for the URL property
   */
   public void setURL(java.lang.String value)
   {
      this.URL = value;
   }

   /*****************************************************************************
   * execute action method
   * @exception java.io.IOException
   * @exception java.lang.Exception
   */
   public void execute()
   throws java.io.IOException, java.lang.Exception
   {
      connection = getPooledConnection(URL, driver);
      java.sql.Statement stmt = connection.createStatement();
      ResultSet rs = stmt.executeQuery( "SELECT LINKS.CATEGORY, LINKS.THEURL, LINKS.LINK_NAME " +
                                        "FROM LINKS, PREFERENCES " +
                                        "WHERE ( ( PREFERENCES.LINK_NAME = LINKS.LINK_NAME ) " +
                                        "AND ( ( PREFERENCES.EMPNO = '" + insertQuoteEscape(empno) + "' ) ) ) " +
                                        "ORDER BY LINKS.CATEGORY DESC, LINKS.LINK_NAME" );
      // There will usually be multiple rows.
      while (rs.next())
      {
         LINKS_CATEGORYVector.addElement(rs.getString(1));
         LINKS_URLVector.addElement(rs.getString(2));
         LINKS_LINK_NAMEVector.addElement(rs.getString(3));
      }
      LINKS_CATEGORYVector.trimToSize();
      LINKS_URLVector.trimToSize();
      LINKS_LINK_NAMEVector.trimToSize();
      rs.close();
      stmt.close();
      connection.close();
   }

   /*****************************************************************************
   * Attempts to get a connection from a App Server V3 connection pool.
   *
   * @param URL Contains the database url for the connection
   * @param driver Contains the JDBC driver name to use for the connection
   * @return a pooled JDBC connection or null
   */
   protected Connection getPooledConnection(String URL, String driver)
   {
      Connection conn = null;

      try
      {
         // create parameter list to access naming system
         Hashtable parms = new Hashtable();
         parms.put(Context.INITIAL_CONTEXT_FACTORY, "com.ibm.ejs.ns.jndi.CNInitialContextFactory");
         // access naming system
         Context context = new InitialContext(parms);
         // get DataSource factory object from naming system
         ds = (DataSource)context.lookup("jdbc/anyname");
         conn = ds.getConnection("anyuser", "anypassword");
      }
      catch (Throwable t)
      {
         // DataSource not found. Try to construct a new DataSource.
         // It will be used by all subsequent IDB samples.
         try
         {
            com.ibm.websphere.advanced.cm.factory.DataSourceFactory factory = new com.ibm.websphere.advanced.cm.factory.DataSourceFactory();
            Attributes attrs = new Attributes();
            attrs.name   = "anyname";
            attrs.driver = driver;
            attrs.url    = URL;
            attrs.max = 30;
            ds = factory.createJDBCDataSource(attrs);
            conn = ds.getConnection("anyuser", "anypassword");
            try
            {
               factory.bindDataSource(ds);
            }
            catch (javax.naming.NamingException namingExc)
            {
            }
         }
         catch (Throwable t1)
         {
            t1.printStackTrace();
         }
      }
      return conn;
   }

   /*****************************************************************************
   * InstantDB fails with SQL text string containing single quote ' - needs escaped
   * single quote \' to work properly.
   * Let's meet
   * ...converted to...
   * Let\'s meet
   * Also, backslash \ needs to be escaped.
   * C:\wombat
   * ...converted to...
   * C:\\wombat
   * Must handle \ and ' combination.
   * O\'DONNEL
   ...converted to...
   * O\\\'DONNEL
   *
   * @param String possibly containing a single quote
   * @return String with single quote escaped
   */
   private String insertQuoteEscape(String input)
   {
      // Turns O\'DONNEL to O\\'DONNEL (escape the \)
      // Escape the \ first, or else we would mistakenly
      // escape the \ added to escape the '.
      StringBuffer buffer = new StringBuffer(input.length());
      char testChar;
      for (int i = 0; i < input.length(); i++)
      {
         testChar = input.charAt(i);
         if (testChar == '\\')
         {
            buffer.append('\\');
         }
         buffer.append(testChar);
      }
      String input1 = buffer.toString();
      // Turns O\\'DONNEL to O\\\'DONNEL (escape the ')
      StringBuffer buffer1 = new StringBuffer(input1.length());
      for (int j = 0; j < input1.length(); j++)
      {
         testChar = input1.charAt(j);
         if (testChar == '\'')
         {
            buffer1.append('\\');
         }
         buffer1.append(testChar);
      }
      return buffer1.toString();
   }
}
