// 5648-C84, 5648-C83, (C) Copyright IBM Corporation, 1997, 2000
// All rights reserved. Licensed Materials Property of IBM
// Note to US Government users: Documentation related to restricted rights
// Use, duplication or disclosure is subject to restrictions set forth in GSA ADP Schedule with IBM Corp.
// This page may contain other proprietary notices and copyright information, the terms of which must be observed and followed.
//
// This program may be used, executed, copied, modified and distributed
// without royalty for the purpose of developing, using,
// marketing, or distributing.

/**
*
* Description - AddJobDBBean
*/
package WebSphereSamples.YourCo.Jobs;
// Imports
import com.ibm.db.*;
import com.ibm.webtools.runtime.*;
import java.io.*;
import java.math.*;

// Imports for App Server V3 connection pooling
import javax.sql.DataSource;
import com.ibm.ejs.dbm.jdbcext.*;
import java.sql.*;
import java.util.*;
import com.ibm.websphere.advanced.cm.factory.*;
import javax.naming.*;

public class AddJobDBBean extends java.lang.Object
{
   /**
   * Instance variable for date property
   */
   protected java.lang.String date = null;

   /**
   * Instance variable for dept property
   */
   protected java.lang.String dept = null;

   /**
   * Instance variable for description property
   */
   protected java.lang.String description = null;

   /**
   * Instance variable for driver property
   */
   protected java.lang.String driver = null;

   /**
   * Instance variable for level property
   */
   protected java.lang.String level = null;

   /**
   * Instance variable for position property
   */
   protected java.lang.String position = null;

   /**
   * Instance variable for URL property
   */
   protected java.lang.String URL = null;

   /**
   * Variable to hold DataSource
   */
   protected DataSource ds = null;

   /**
   * Variable to hold connection
   */
   protected Connection connection = null;

   /*****************************************************************************
   * Get method for the date property
   * @return the value of the date property
   */
   public java.lang.String getDate()
   {
      return date;
   }

   /*****************************************************************************
   * Set method for the date property
   * @param value the new value for the date property
   */
   public void setDate(java.lang.String value)
   {
      this.date = value;
   }

   /*****************************************************************************
   * Get method for the dept property
   * @return the value of the dept property
   */
   public java.lang.String getDept()
   {
      return dept;
   }

   /*****************************************************************************
   * Set method for the dept property
   * @param value the new value for the dept property
   */
   public void setDept(java.lang.String value)
   {
      this.dept = value;
   }

   /*****************************************************************************
   * Get method for the description property
   * @return the value of the description property
   */
   public java.lang.String getDescription()
   {
      return description;
   }

   /*****************************************************************************
   * Set method for the description property
   * @param value the new value for the description property
   */
   public void setDescription(java.lang.String value)
   {
      this.description = value;
   }

   /*****************************************************************************
   * Get method for the driver property
   * @return the value of the driver property
   */
   public java.lang.String getDriver()
   {
      return driver;
   }

   /*****************************************************************************
   * Set method for the driver property
   * @param value the new value for the driver property
   */
   public void setDriver(java.lang.String value)
   {
      this.driver = value;
   }

   /*****************************************************************************
   * Get method for the level property
   * @return the value of the level property
   */
   public java.lang.String getLevel()
   {
      return level;
   }

   /*****************************************************************************
   * Set method for the level property
   * @param value the new value for the level property
   */
   public void setLevel(java.lang.String value)
   {
      this.level = value;
   }

   /*****************************************************************************
   * Get method for the position property
   * @return the value of the position property
   */
   public java.lang.String getPosition()
   {
      return position;
   }

   /*****************************************************************************
   * Set method for the position property
   * @param value the new value for the position property
   */
   public void setPosition(java.lang.String value)
   {
      this.position = value;
   }

   /*****************************************************************************
   * Get method for the URL property
   * @return the value of the URL property
   */
   public java.lang.String getURL()
   {
      return URL;
   }

   /*****************************************************************************
   * Set method for the URL property
   * @param value the new value for the URL property
   */
   public void setURL(java.lang.String value)
   {
      this.URL = value;
   }

   /*****************************************************************************
   * execute action method
   * @exception java.io.IOException
   * @exception java.lang.Exception
   */
   public void execute()
   throws java.io.IOException, java.lang.Exception
   {
      connection = getPooledConnection(URL, driver);
      java.sql.Statement stmt = connection.createStatement();
      stmt.executeUpdate("INSERT INTO JOBS ( POST_DATE, POSITION, THELEVEL, DESCRIPTION, DEPT_NO ) " +
                         "VALUES ( " +
                         "'" + insertQuoteEscape(date) + "', " +
                         "'" + insertQuoteEscape(position) + "', " +
                         "'" + insertQuoteEscape(level) + "', " +
                         "'" + insertQuoteEscape(description) + "', " +
                         "'" + insertQuoteEscape(dept) + "') " );
      stmt.close();
      connection.close();
   }

   /*****************************************************************************
   * Attempts to get a connection from a App Server V3 connection pool.
   *
   * @param URL Contains the database url for the connection
   * @param driver Contains the JDBC driver name to use for the connection
   * @return a pooled JDBC connection or null
   */
   protected Connection getPooledConnection(String URL, String driver)
   {
      Connection conn = null;

      try
      {
         // create parameter list to access naming system
         Hashtable parms = new Hashtable();
         parms.put(Context.INITIAL_CONTEXT_FACTORY, "com.ibm.ejs.ns.jndi.CNInitialContextFactory");
         // access naming system
         Context context = new InitialContext(parms);
         // get DataSource factory object from naming system
         ds = (DataSource)context.lookup("jdbc/anyname");
         conn = ds.getConnection("anyuser", "anypassword");
      }
      catch (Throwable t)
      {
         // DataSource not found. Try to construct a new DataSource.
         // It will be used by all subsequent IDB samples.
         try
         {
            com.ibm.websphere.advanced.cm.factory.DataSourceFactory factory = new com.ibm.websphere.advanced.cm.factory.DataSourceFactory();
            Attributes attrs = new Attributes();
            attrs.name   = "anyname";
            attrs.driver = driver;
            attrs.url    = URL;
            attrs.max = 30;
            ds = factory.createJDBCDataSource(attrs);
            conn = ds.getConnection("anyuser", "anypassword");
            try
            {
               factory.bindDataSource(ds);
            }
            catch (javax.naming.NamingException namingExc)
            {
            }
         }
         catch (Throwable t1)
         {
            t1.printStackTrace();
         }
      }
      return conn;
   }

   /*****************************************************************************
   * InstantDB fails with SQL text string containing single quote ' - needs escaped
   * single quote \' to work properly.
   * Let's meet
   * ...converted to...
   * Let\'s meet
   * Also, backslash \ needs to be escaped.
   * C:\wombat
   * ...converted to...
   * C:\\wombat
   * Must handle \ and ' combination.
   * O\'DONNEL
   ...converted to...
   * O\\\'DONNEL
   *
   * @param String possibly containing a single quote
   * @return String with single quote escaped
   */
   private String insertQuoteEscape(String input)
   {
      // Turns O\'DONNEL to O\\'DONNEL (escape the \)
      // Escape the \ first, or else we would mistakenly
      // escape the \ added to escape the '.
      StringBuffer buffer = new StringBuffer(input.length());
      char testChar;
      for (int i = 0; i < input.length(); i++)
      {
         testChar = input.charAt(i);
         if (testChar == '\\')
         {
            buffer.append('\\');
         }
         buffer.append(testChar);
      }
      String input1 = buffer.toString();
      // Turns O\\'DONNEL to O\\\'DONNEL (escape the ')
      StringBuffer buffer1 = new StringBuffer(input1.length());
      for (int j = 0; j < input1.length(); j++)
      {
         testChar = input1.charAt(j);
         if (testChar == '\'')
         {
            buffer1.append('\\');
         }
         buffer1.append(testChar);
      }
      return buffer1.toString();
   }
}
