// 5648-C84, 5648-C83, (C) Copyright IBM Corporation, 1997, 2000
// All rights reserved. Licensed Materials Property of IBM
// Note to US Government users: Documentation related to restricted rights
// Use, duplication or disclosure is subject to restrictions set forth in GSA ADP Schedule with IBM Corp.
// This page may contain other proprietary notices and copyright information, the terms of which must be observed and followed.
//
// This program may be used, executed, copied, modified and distributed
// without royalty for the purpose of developing, using,
// marketing, or distributing.

/**
*
* Description - PollServlet
*
*/ 
package WebSphereSamples.YourCo.Poll;

// Imports
import com.ibm.servlet.*;
import com.ibm.webtools.runtime.*;
import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;

// Imports for beans used by this servlet
import WebSphereSamples.YourCo.Poll.PollQueryBean;
import WebSphereSamples.YourCo.Poll.PollUpdateBean;

public class PollServlet extends com.ibm.webtools.runtime.StudioPervasiveServlet implements Serializable
{

   /*****************************************************************************
   * Process incoming requests for information
   * 
   * @param request Object that encapsulates the request to the servlet
   * @param response Object that encapsulates the response from the servlet
   */
   public void performTask(HttpServletRequest request, HttpServletResponse response)
   {
      try
      {
         // form input parameters
         String pollId = getParameter(request, "pollId", true, true, true, null);
         String vote = getParameter(request, "vote", true, true, true, null);

         // to be fetched from database as pollQueryBean properties
         int yesVote = 0;
         int noVote = 0;

         HttpSession session = request.getSession(true);

         // instantiate the beans and store them so they can be accessed by the called page
         WebSphereSamples.YourCo.Poll.PollQueryBean pollQueryBean = null;
         pollQueryBean = (WebSphereSamples.YourCo.Poll.PollQueryBean) java.beans.Beans.instantiate(getClass().getClassLoader(), "WebSphereSamples.YourCo.Poll.PollQueryBean");

         WebSphereSamples.YourCo.Poll.PollUpdateBean pollUpdateBean = null;
         pollUpdateBean = (WebSphereSamples.YourCo.Poll.PollUpdateBean) java.beans.Beans.instantiate(getClass().getClassLoader(), "WebSphereSamples.YourCo.Poll.PollUpdateBean");

         session.putValue("pollUpdateBean", pollUpdateBean);

         // Initialize the bean URL property from the webapp URL attribute
         pollQueryBean.setURL((String)getServletConfig().getServletContext().getAttribute("URL"));

         // Initialize the bean driver property from the parameters
         pollQueryBean.setDriver(getParameter(request, "driver", true, true, false, null));

         // Specify which poll question in the database is being answered
         pollQueryBean.setPollId(getParameter(request, "pollId", true, true, false, null));

         // Call the execute action on the bean.
         pollQueryBean.execute();

         // Get the number of yes and no votes from the database using the pollQueryBean
         yesVote = pollQueryBean.getPOLL_YES().intValue();
         noVote = pollQueryBean.getPOLL_NO().intValue();

         if (vote.equals("yes"))
         {
            yesVote++;
         }
         else if (vote.equals("no"))
         {
            noVote++;
         }
         else
         {
            throw new Exception("Invalid or null selection");
         }

         // Initialize the bean URL property from the webapp URL attribute
         pollUpdateBean.setURL((String)getServletConfig().getServletContext().getAttribute("URL"));

         // Initialize the bean driver property from the parameters
         pollUpdateBean.setDriver(getParameter(request, "driver", true, true, false, null));

         // Specify which poll question in the database is being answered
         pollUpdateBean.setPollId(getParameter(request, "pollId", true, true, false, null));

         // Initialize the bean yesVote property from the parameters
         pollUpdateBean.setYesVote( String.valueOf(yesVote) );

         // Initialize the bean noVote property from the parameters
         pollUpdateBean.setNoVote( String.valueOf(noVote) );

         // Call the execute action on the bean.
         pollUpdateBean.execute();

         // Call the output page. If the output page is not passed
         // as part of the URL, the default page is called.
         callPage(getPageNameFromRequest(request), request, response);

      }

      catch (Throwable theException)
      {
         handleError(request, response, theException);
      }
   }
}
