// 5648-C84, 5648-C83, (C) Copyright IBM Corporation, 1997, 2000
// All rights reserved. Licensed Materials Property of IBM
// Note to US Government users: Documentation related to restricted rights
// Use, duplication or disclosure is subject to restrictions set forth in GSA ADP Schedule with IBM Corp.
// This page may contain other proprietary notices and copyright information, the terms of which must be observed and followed.
//
// This program may be used, executed, copied, modified and distributed
// without royalty for the purpose of developing, using,
// marketing, or distributing.

/**
*
* Description - ByJobDBBean
*/
package WebSphereSamples.YourCo.Search;
// Imports
import com.ibm.db.*;
import com.ibm.webtools.runtime.*;
import java.io.*;
import java.math.*;

// Imports for App Server V3 connection pooling
import javax.sql.DataSource;
import com.ibm.ejs.dbm.jdbcext.*;
import java.sql.*;
import java.util.*;
import com.ibm.websphere.advanced.cm.factory.*;
import javax.naming.*;

public class ByJobDBBean extends java.lang.Object
{
   /**
   * Instance variable for driver property
   */
   protected java.lang.String driver = null;

   /**
   * Instance variable for job property
   */
   protected java.lang.String job = null;

   /**
   * Instance variable for URL property
   */
   protected java.lang.String URL = null;

   /**
   * Variable to hold DataSource
   */
   protected DataSource ds = null;

   /**
   * Variable to hold connection
   */
   protected Connection connection = null;
   /**
   * Vector to hold EMPLOYEE_FIRSTNME property values
   */
   protected Vector EMPLOYEE_FIRSTNMEVector = new Vector();

   /**
   * Vector to hold EMPLOYEE_LASTNAME property values
   */
   protected Vector EMPLOYEE_LASTNAMEVector = new Vector();

   /**
   * Vector to hold EMPLOYEE_PHONENO property values
   */
   protected Vector EMPLOYEE_PHONENOVector = new Vector();

   /**
    * Vector to hold DEPARTMENT_DEPTNAME property values
   */
   protected Vector DEPARTMENT_DEPTNAMEVector = new Vector();

   /**
   * Vector to hold EMPLOYEE_JOB property values
   */
   protected Vector EMPLOYEE_JOBVector = new Vector();

   /**
   * Vector to hold EMPLOYEE_HIREDATE property values
   */
   protected Vector EMPLOYEE_HIREDATEVector = new Vector();

   /**
   * Vector to hold EMPLOYEE_SALARY property values
   */
   protected Vector EMPLOYEE_SALARYVector = new Vector();


   /*****************************************************************************
   * Get method for the indexed EMPLOYEE_FIRSTNME property
   * @param index The 0 based index of the desired value
   * @return the value of the EMPLOYEE_FIRSTNME property at the specified index
   */
   public java.lang.String getEMPLOYEE_FIRSTNME(int index)
   throws java.lang.ArrayIndexOutOfBoundsException
   {
      return (String)EMPLOYEE_FIRSTNMEVector.elementAt(index);
   }

   /*****************************************************************************
   * Get method for the indexed EMPLOYEE_LASTNAME property
   * @param index The 0 based index of the desired value
   * @return the value of the EMPLOYEE_LASTNAME property at the specified index
   */
   public java.lang.String getEMPLOYEE_LASTNAME(int index)
   throws java.lang.ArrayIndexOutOfBoundsException
   {
      return (String)EMPLOYEE_LASTNAMEVector.elementAt(index);
   }

   /*****************************************************************************
   * Get method for the indexed EMPLOYEE_PHONENO property
   * @param index The 0 based index of the desired value
   * @return the value of the EMPLOYEE_PHONENO property at the specified index
   */
   public java.lang.String getEMPLOYEE_PHONENO(int index)
   throws java.lang.ArrayIndexOutOfBoundsException
   {
      return (String)EMPLOYEE_PHONENOVector.elementAt(index);
   }

   /*****************************************************************************
   * Get method for the indexed DEPARTMENT_DEPTNAME property
   * @param index The 0 based index of the desired value
   * @return the value of the DEPARTMENT_DEPTNAME property at the specified index
   */
   public java.lang.String getDEPARTMENT_DEPTNAME(int index)
   throws java.lang.ArrayIndexOutOfBoundsException
   {
      return (String)DEPARTMENT_DEPTNAMEVector.elementAt(index);
   }

   /*****************************************************************************
   * Get method for the indexed EMPLOYEE_JOB property
   * @param index The 0 based index of the desired value
   * @return the value of the EMPLOYEE_JOB property at the specified index
   */
   public java.lang.String getEMPLOYEE_JOB(int index)
   throws java.lang.ArrayIndexOutOfBoundsException
   {
      return (String)EMPLOYEE_JOBVector.elementAt(index);
   }

   /*****************************************************************************
   * Get method for the indexed EMPLOYEE_HIREDATE property
   * @param index The 0 based index of the desired value
   * @return the value of the EMPLOYEE_HIREDATE property at the specified index
   */
   public java.lang.String getEMPLOYEE_HIREDATE(int index)
   throws java.lang.ArrayIndexOutOfBoundsException
   {
      return (String)EMPLOYEE_HIREDATEVector.elementAt(index);
   }

   /*****************************************************************************
   * Get method for the indexed EMPLOYEE_SALARY property
   * @param index The 0 based index of the desired value
   * @return the value of the EMPLOYEE_SALARY property at the specified index
   */
   public java.math.BigDecimal getEMPLOYEE_SALARY(int index)
   throws java.lang.ArrayIndexOutOfBoundsException
   {
      return new java.math.BigDecimal((String)EMPLOYEE_SALARYVector.elementAt(index));
   }

   /*****************************************************************************
   * Get method for the driver property
   * @return the value of the driver property
   */
   public java.lang.String getDriver()
   {
      return driver;
   }

   /*****************************************************************************
   * Set method for the driver property
   * @param value the new value for the driver property
   */
   public void setDriver(java.lang.String value)
   {
      this.driver = value;
   }

   /*****************************************************************************
   * Get method for the job property
   * @return the value of the job property
   */
   public java.lang.String getJob()
   {
      return job;
   }

   /*****************************************************************************
   * Set method for the job property
   * @param value the new value for the job property
   */
   public void setJob(java.lang.String value)
   {
      this.job = value;
   }

   /*****************************************************************************
   * Get method for the URL property
   * @return the value of the URL property
   */
   public java.lang.String getURL()
   {
      return URL;
   }

   /*****************************************************************************
   * Set method for the URL property
   * @param value the new value for the URL property
   */
   public void setURL(java.lang.String value)
   {
      this.URL = value;
   }

   /*****************************************************************************
   * execute action method
   * @exception java.io.IOException
   * @exception java.lang.Exception
   */
   public void execute()
   throws java.io.IOException, java.lang.Exception
   {
      connection = getPooledConnection(URL, driver);
      java.sql.Statement stmt = connection.createStatement();
      ResultSet rs = stmt.executeQuery("SELECT EMPLOYEE.FIRSTNME, EMPLOYEE.LASTNAME, EMPLOYEE.PHONENO, " +
                                       "DEPARTMENT.DEPTNAME, EMPLOYEE.JOB, EMPLOYEE.HIREDATE, EMPLOYEE.SALARY " +
                                       "FROM DEPARTMENT, EMPLOYEE " +
                                       "WHERE ( ( EMPLOYEE.WORKDEPT = DEPARTMENT.DEPTNO ) AND " +
                                       "( ( EMPLOYEE.JOB = '" + insertQuoteEscape(job) + "' ) ) ) " +
                                       "ORDER BY EMPLOYEE.LASTNAME, EMPLOYEE.FIRSTNME");
      // There will usually be multiple rows.
      while (rs.next())
      {
         EMPLOYEE_FIRSTNMEVector.addElement(rs.getString(1));
         EMPLOYEE_LASTNAMEVector.addElement(rs.getString(2));
         EMPLOYEE_PHONENOVector.addElement(rs.getString(3));
         DEPARTMENT_DEPTNAMEVector.addElement(rs.getString(4));
         EMPLOYEE_JOBVector.addElement(rs.getString(5));
         EMPLOYEE_HIREDATEVector.addElement(rs.getString(6));
         EMPLOYEE_SALARYVector.addElement(rs.getString(7));
      }
      EMPLOYEE_FIRSTNMEVector.trimToSize();
      EMPLOYEE_LASTNAMEVector.trimToSize();
      EMPLOYEE_PHONENOVector.trimToSize();
      DEPARTMENT_DEPTNAMEVector.trimToSize();
      EMPLOYEE_JOBVector.trimToSize();
      EMPLOYEE_HIREDATEVector.trimToSize();
      EMPLOYEE_SALARYVector.trimToSize();
      rs.close();
      stmt.close();
      connection.close();
   }

   /*****************************************************************************
   * Attempts to get a connection from a App Server V3 connection pool.
   *
   * @param URL Contains the database url for the connection
   * @param driver Contains the JDBC driver name to use for the connection
   * @return a pooled JDBC connection or null
   */
   protected Connection getPooledConnection(String URL, String driver)
   {
      Connection conn = null;

      try
      {
         // create parameter list to access naming system
         Hashtable parms = new Hashtable();
         parms.put(Context.INITIAL_CONTEXT_FACTORY, "com.ibm.ejs.ns.jndi.CNInitialContextFactory");
         // access naming system
         Context context = new InitialContext(parms);
         // get DataSource factory object from naming system
         ds = (DataSource)context.lookup("jdbc/anyname");
         conn = ds.getConnection("anyuser", "anypassword");
      }
      catch (Throwable t)
      {
         // DataSource not found. Try to construct a new DataSource.
         // It will be used by all subsequent IDB samples.
         try
         {
            com.ibm.websphere.advanced.cm.factory.DataSourceFactory factory = new com.ibm.websphere.advanced.cm.factory.DataSourceFactory();
            Attributes attrs = new Attributes();
            attrs.name   = "anyname";
            attrs.driver = driver;
            attrs.url    = URL;
            attrs.max = 30;
            ds = factory.createJDBCDataSource(attrs);
            conn = ds.getConnection("anyuser", "anypassword");
            try
            {
               factory.bindDataSource(ds);
            }
            catch (javax.naming.NamingException namingExc)
            {
            }
         }
         catch (Throwable t1)
         {
            t1.printStackTrace();
         }
      }
      return conn;
   }

   /*****************************************************************************
   * InstantDB fails with SQL text string containing single quote ' - needs escaped
   * single quote \' to work properly.
   * Let's meet
   * ...converted to...
   * Let\'s meet
   * Also, backslash \ needs to be escaped.
   * C:\wombat
   * ...converted to...
   * C:\\wombat
   * Must handle \ and ' combination.
   * O\'DONNEL
   ...converted to...
   * O\\\'DONNEL
   *
   * @param String possibly containing a single quote
   * @return String with single quote escaped
   */
   private String insertQuoteEscape(String input)
   {
      // Turns O\'DONNEL to O\\'DONNEL (escape the \)
      // Escape the \ first, or else we would mistakenly
      // escape the \ added to escape the '.
      StringBuffer buffer = new StringBuffer(input.length());
      char testChar;
      for (int i = 0; i < input.length(); i++)
      {
         testChar = input.charAt(i);
         if (testChar == '\\')
         {
            buffer.append('\\');
         }
         buffer.append(testChar);
      }
      String input1 = buffer.toString();
      // Turns O\\'DONNEL to O\\\'DONNEL (escape the ')
      StringBuffer buffer1 = new StringBuffer(input1.length());
      for (int j = 0; j < input1.length(); j++)
      {
         testChar = input1.charAt(j);
         if (testChar == '\'')
         {
            buffer1.append('\\');
         }
         buffer1.append(testChar);
      }
      return buffer1.toString();
   }
}
