// 5648-C84, 5648-C83, (C) Copyright IBM Corporation, 1997, 2000
// All rights reserved. Licensed Materials Property of IBM
// Note to US Government users: Documentation related to restricted rights
// Use, duplication or disclosure is subject to restrictions set forth in GSA ADP Schedule with IBM Corp.
// This page may contain other proprietary notices and copyright information, the terms of which must be observed and followed.
//
// This program may be used, executed, copied, modified and distributed
// without royalty for the purpose of developing, using,
// marketing, or distributing.

/**
* This file was generated by IBM WebSphere Studio Version 3.0.0
* D:\WebSphere\StudioBeta\BIN\GENERATIONSTYLESHEETS\APPSERVERV2\WEBSPHERE\JavaServlet.xsl stylesheet was used to generate this file.
*
* 
*
*/ 
package WebSphereSamples.UserProfile;

import java.io.*;
import java.util.*;

import javax.servlet.*;
import javax.servlet.http.*;

import com.ibm.websphere.userprofile.UserProfile;
import com.ibm.websphere.userprofile.UserProfileManager;
import com.ibm.websphere.userprofile.UserProfileCreateException;
import com.ibm.websphere.userprofile.UserProfileFinderException;
import com.ibm.websphere.userprofile.UserProfileRemoveException;

public class UserProfileServlet extends com.ibm.webtools.runtime.StudioPervasiveServlet implements java.io.Serializable
{


  /*****************************************************************************
  * Process incoming requests for information
  * 
  * @param request Object that encapsulates the request to the servlet
  * @param response Object that encapsulates the response from the servlet
  */
  public void performTask(javax.servlet.http.HttpServletRequest request, javax.servlet.http.HttpServletResponse response)
  {
    try 
    {
      javax.servlet.http.HttpSession session = request.getSession(true);
    
      UserProfileManager manager = UserProfileManager.getUserProfileManager();
      com.ibm.websphere.userprofile.UserProfile userProfile = null;

      String username = null;
      username = getParameter(request, "username", true, true, true, null);

      String page = null;
      page = getPageNameFromRequest(request);

      try
      {
        // try to create the user profile
        userProfile = manager.addUserProfile( username );

        userProfile.setFirstName(getParameter(request, "firstname", true, true, true, null));
        userProfile.setSurName(getParameter(request, "lastname", true, true, true, null));
        userProfile.setAddress1(getParameter(request, "address", true, true, true, null));
        userProfile.setDayPhone(getParameter(request, "phone", true, true, true, null));
        userProfile.setCity(getParameter(request, "city", true, true, true, null));
        userProfile.setStateOrProvince(getParameter(request, "state", true, true, true, null));
        userProfile.setPostalCode(getParameter(request, "zipcode", true, true, true, null));
        userProfile.setEmail(getParameter(request, "email", true, true, true, null));
      }
      // if user profile for the username already exists
      catch(UserProfileCreateException e)
      {
        //try to find the existing user profile in read-only mode
        userProfile = manager.getUserProfile(username, false);
        page = "DuplicateUserPage";
      }

      // put the user profile in the current session
      session.putValue("userProfile", userProfile);

      // Call the output page. If the output page is not passed
      // as part of the URL, the default page is called.
      callPage(page, request, response);
    }
    catch (Exception theException)
    {
      handleError(request, response, theException);
    }
  }

}
